import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';

import '../../requester/requester.dart';

class DataRequired extends StatefulWidget {
  final Future<dynamic> Function(GlobalInformation) fetchData;
  final Widget Function(dynamic) afterLoading;
  final double height;
  final double width;
  const DataRequired({super.key, required this.fetchData, required this.afterLoading, this.height = -1, this.width = -1});

  @override
  State<DataRequired> createState() => DataRequiredState();
}

class DataRequiredState extends State<DataRequired> {
  bool isLoading = true;
  dynamic data = {};
  void _fetch() async {
    var data = await widget.fetchData(GlobalInformation.getInstance());
    if (kDebugMode) {
      print(data);
    }
    setState(() {
      isLoading = false;
      if (data['code'] == 200){
        this.data = data;
      }
    });
  }
  @override
  void initState() {
    super.initState();
    _fetch();
  }
  @override
  Widget build(BuildContext context) {
    if (kDebugMode) {
      print(data);
    }
    if (kDebugMode) {
      print("rebuild");
    }
    if (isLoading || data.isEmpty){
      var placeholder = const Placeholder();
      if (widget.height != -1) {
        placeholder = Placeholder(fallbackHeight: widget.height);
        if (widget.width != -1) {
          placeholder = Placeholder(fallbackHeight: widget.height, fallbackWidth: widget.width);
        }
      }
      if (widget.width != -1) {
        placeholder = Placeholder(fallbackWidth: widget.width, fallbackHeight: widget.height);
      }
      return Stack(
        children: [
          placeholder,
          Center(
            child: data.isEmpty ? const CircularProgressIndicator() : const Text("加载失败，网络错误！"),
          )
        ],
      );
    }
    if (kDebugMode) {
      print("loading");
    }
    if (data.isNotEmpty){
      return widget.afterLoading(data);
    }
    return const Center(child: Text("加载失败，网络错误！"));
  }

  void update() {
    _fetch();
  }
}
